
import javax.vecmath.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.*;

public class AmbientLightExample extends BasicScene 
{
  public static void main(String args[]){new AmbientLightExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    // Create an yellow ambient light
    AmbientLight light = new AmbientLight(new Color3f(1.0f, 1.0f, 0.0f));
    BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 
        Double.POSITIVE_INFINITY);
    light.setInfluencingBounds(bounds);
    root.addChild(light);
    
    // Create a cyan material
    Appearance appearance = new Appearance();
    Material material = new Material();
    material.setAmbientColor(new Color3f(0.0f, 1.0f, 1.0f));
    appearance.setMaterial(material);
    
    // Create a sphere of radius 40 cm
    Sphere sphere = new Sphere(0.4f, appearance);
    root.addChild(sphere);
    
    root.compile();

    return root;
  }
}

