
import javax.media.j3d.*;

import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.*;
import javax.vecmath.*;

public class BackgroundGeometryExample extends 
  BasicSceneWithMouseControlAndLights
{
  public static void main(String args[]){new BackgroundGeometryExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
  
    Texture starTexture = null;
    try
    {
      // Load the stars texture 
      TextureLoader loader = new TextureLoader("stars.gif", this);
      starTexture = loader.getTexture();
    }
    catch(Exception e){System.out.println(e.toString());}

    // Create a backgound node with maximum bounds
    Background background = new Background();
    background.setApplicationBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    
    BranchGroup backgroundGroup = new BranchGroup();
    
    // Set the texture for the background appearance
    Appearance backgroundAppearance = new Appearance();
    backgroundAppearance.setTexture(starTexture);
    
    // Create a detailed sphere with normal pointing inwards
    Sphere backgroundSphere = new Sphere(0.5f,
        Sphere.GENERATE_TEXTURE_COORDS|
        Sphere.GENERATE_NORMALS_INWARD, 
        100, backgroundAppearance);
    backgroundGroup.addChild(backgroundSphere);
    background.setGeometry(backgroundGroup);
    root.addChild(background);
   
    // Create the earth sphere
    Appearance earthAppearance = new Appearance();
    
    Material earthMaterial = new Material();
    earthAppearance.setMaterial(earthMaterial);
    
    Texture earthTexture = null;
    try
    {
      TextureLoader loader = new TextureLoader("earth.jpg", this);
      earthTexture = loader.getTexture();
    }
    catch(Exception e){System.out.println(e.toString());}
    earthAppearance.setTexture(earthTexture);
    
    Sphere earthSphere = new Sphere(0.5f,
        Sphere.GENERATE_TEXTURE_COORDS|
        Sphere.GENERATE_NORMALS, 
        100, earthAppearance);
    root.addChild(earthSphere);
  
    root.compile();
   
    return root;
  }
}

