
import javax.media.j3d.*;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.*;
import javax.vecmath.*;

public class BackgroundImageExample extends 
   BasicSceneWithMouseControlAndLights 
{
  public static void main(String args[]){new BackgroundImageExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    ImageComponent2D starImage = null;
    try
    {
      // Load the stars image
      TextureLoader loader = new TextureLoader("stars.gif", this);
      starImage = loader.getImage();
    }
    catch(Exception e){System.out.println(e.toString());}
    
    // Create a background node from the stars image
    Background bg = new Background(starImage);
    bg.setApplicationBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    root.addChild(bg);
    
    Appearance appearance = new Appearance();
    
    Material material = new Material();
    appearance.setMaterial(material);
    
    Texture earthTexture = null;
    try
    {
      // Load the earth texture
      TextureLoader loader = new TextureLoader("earth.jpg", this);
      earthTexture = loader.getTexture();
    }
    catch(Exception e){System.out.println(e.toString());}
    appearance.setTexture(earthTexture);
    
    // Allow the texture to respond to lighting
    TextureAttributes textureAttributes = new TextureAttributes();
    textureAttributes.setTextureMode(TextureAttributes.MODULATE);
    appearance.setTextureAttributes(textureAttributes);
   
    // Create a details sphere and map the earth texture
    Sphere sphere = new Sphere(0.5f,
        Sphere.GENERATE_TEXTURE_COORDS|Sphere.GENERATE_NORMALS, 
        100, appearance);
    root.addChild(sphere);
  
    root.compile();

    return root;
  }
}

