import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.geometry.*;

public class LinearFogExample extends BasicScene{
  
  public static void main(String args[]){new LinearFogExample();}
  
  public BranchGroup createContentBranch()
  {
    BranchGroup root = new BranchGroup();
    
    // Define a backgound with a constant mid grey colour
    Background background = new Background(new Color3f(0.5f, 0.5f, 0.5f));
    background.setApplicationBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    root.addChild(background);
    
    // Define a linear fog node with the same colour as the background
    LinearFog linearFog = new LinearFog(new Color3f(0.5f, 0.5f, 0.5f), 1.0, 10.0);
    linearFog.setInfluencingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    root.addChild(linearFog);
    
    TransformGroup tg = new TransformGroup();
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(tg);
   
    // Include support for mouse zoom
    MouseZoom zoom = new MouseZoom();
    zoom.setTransformGroup(tg);
    tg.addChild(zoom);
    zoom.setSchedulingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    
    // Include support for mouse rotate
    MouseRotate rotate = new MouseRotate();
    rotate.setTransformGroup(tg);
    tg.addChild(rotate);
    rotate.setSchedulingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    
    ColorCube colorCube = new ColorCube(0.4f);
    tg.addChild(colorCube);
    
    return root;
  }
}