
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.*;

public class MagnificationFilterExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new MagnificationFilterExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    Appearance appearance = new Appearance();
    
    Texture earthTexture = null;
    try
    {
      // Load the texture and set its magnification filter
      TextureLoader loader = new TextureLoader("earth.jpg", this);
      earthTexture = loader.getTexture();
      earthTexture.setMagFilter(Texture.BASE_LEVEL_LINEAR);
      
    }
    catch(Exception e){System.out.println(e.toString());}
    
    appearance.setTexture(earthTexture);
    
    // Use the texture in conjucntion with a sphere geometry
    Sphere sphere = new Sphere(0.5f, 
        Sphere.GENERATE_TEXTURE_COORDS, 
        appearance);
    root.addChild(sphere);
    
    root.compile();

    return root;
  }
}

