import javax.media.j3d.*;
import javax.vecmath.*;
import java.lang.*;

import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import com.sun.j3d.utils.geometry.*;

public class SpotLightExample extends BasicScene
{
  public static void main(String args[]){new SpotLightExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
    
    Transform3D transform1 = new Transform3D();
    transform1.setTranslation(new Vector3f(0.0f, 0.0f, -20.0f));
    TransformGroup tg1 = new TransformGroup(transform1);
    root.addChild(tg1);
    
    // Red appearance
    Appearance appearance1 = new Appearance();
    Material material1 = new Material();
    material1.setDiffuseColor(new Color3f(1.0f, 0.0f, 0.0f));
    appearance1.setMaterial(material1);
    
    // A detailed sphere with a large radius
    Sphere sphere1 = new Sphere(15.0f, Primitive.GENERATE_NORMALS, 
        500, appearance1);
    tg1.addChild(sphere1);
    
    TransformGroup tg2 = new TransformGroup();
    tg2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    root.addChild(tg2);

    // A mouse rotate behaviour to control the direction of the light
    MouseRotate rotate = new MouseRotate();
    rotate.setTransformGroup(tg2);
    tg2.addChild(rotate);
    rotate.setSchedulingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    
    // A spot light 
    SpotLight light = new SpotLight(); 
    light.setConcentration(45f);
    light.setSpreadAngle((float)Math.toRadians(30));
    light.setInfluencingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    tg2.addChild(light);
    
    root.compile();

    return root;
  }
}
