import javax.media.j3d.*;
import com.sun.j3d.utils.image.*;

public class TexCoordGenerationExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new TexCoordGenerationExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
  
    Texture woodTexture = null;
    
    try
    {
      // Load the wood texture
      TextureLoader loader = new TextureLoader("wood.jpg", this);
      woodTexture = loader.getTexture();
    }
    catch(Exception e){System.out.println(e.toString());}
    
    Appearance appearance = new Appearance();
    appearance.setTexture(woodTexture);
    
    // Defines 2D texture coordinates generated by a linear mapping
    TexCoordGeneration texCoordGeneration = new TexCoordGeneration();
    texCoordGeneration.setFormat(TexCoordGeneration.TEXTURE_COORDINATE_2);
    texCoordGeneration.setGenMode(TexCoordGeneration.OBJECT_LINEAR);
    appearance.setTexCoordGeneration(texCoordGeneration);
    
    float[] coordinates = {-0.5f, -0.5f,  0.0f, 
        0.5f, -0.5f,  0.0f,
        0.0f,  0.5f,  0.0f};
   
    // Create a geometry array from the specified coordinates
    GeometryArray geometryArray = new TriangleArray(3,
    GeometryArray.COORDINATES);
    
    geometryArray.setCoordinates(0, coordinates);
    
    // Create a Shape3D object using the GeometryArray
    Shape3D shape = new Shape3D(geometryArray, appearance);
    root.addChild(shape);
    
    root.compile();

    return root;
  }
}

