import javax.media.j3d.*;
import com.sun.j3d.utils.image.*;

public class TextureBoundaryModeExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new TextureBoundaryModeExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
  
    Texture earthTexture = null;
    
    try
    {
      // Create the texture and set it horizontal and vertical 
      // boundary modes
      TextureLoader loader = new TextureLoader("earth.jpg", this);
      earthTexture = loader.getTexture();
      earthTexture.setBoundaryModeS(Texture.CLAMP);
      earthTexture.setBoundaryModeT(Texture.WRAP);
    }
    catch(Exception e){System.out.println(e.toString());}
    
    Appearance appearance = new Appearance();
    appearance.setTexture(earthTexture);
    
    float[] coordinates = {-0.5f, -0.5f,  0.0f, 
        0.5f, -0.5f,  0.0f,
        0.5f,  0.5f,  0.0f,
        -0.5f,  0.5f,  0.0f};
    
    // Specify the texture coordiantes for the vertices
    float[] texCoords = {-1.0f, -1.0f,
        2.0f, -1.0f,
        2.0f,  2.0f,
        -1.0f,  2.0f};

    // Create a geometry array from the specified coordinates
    GeometryArray geometryArray = new QuadArray(4,
    GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
    
    geometryArray.setCoordinates(0, coordinates);
    geometryArray.setTextureCoordinates(0,0,texCoords);
    
    // Create a Shape3D object using the GeometryArray
    Shape3D shape = new Shape3D(geometryArray, appearance);
    root.addChild(shape);
    
    root.compile();

    return root;
  }
}

