import javax.media.j3d.*;
import com.sun.j3d.utils.image.*;

public class TextureCoordinateExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new TextureCoordinateExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
  
    Texture woodTexture = null;
    
    try
    {
      // Load the wood texture from the local file syste,
      TextureLoader loader = new TextureLoader("wood.jpg", this);
      woodTexture = loader.getTexture();
    }
    catch(Exception e){System.out.println(e.toString());}
    
    Appearance appearance = new Appearance();
    appearance.setTexture(woodTexture);
    
    float[] coordinates = {-0.5f, -0.5f,  0.0f, 
        0.5f, -0.5f,  0.0f,
        0.0f,  0.5f,  0.0f};
    
    // Define the texture coordinates for the vertices
    float[] texCoords = {0.0f, 0.0f,
        1.0f, 0.0f,
        0.5f,  1.0f};

    // Create a geometry array from the specified coordinates
    GeometryArray geometryArray = new TriangleArray(3,
    GeometryArray.COORDINATES|GeometryArray.TEXTURE_COORDINATE_2);
    
    geometryArray.setCoordinates(0, coordinates);
    geometryArray.setTextureCoordinates(0,0,texCoords);
    
    // Create a Shape3D object using the GeometryArray
    Shape3D shape = new Shape3D(geometryArray, appearance);
    root.addChild(shape);
    
    root.compile();

    return root;
  }
}

