
import javax.media.j3d.*;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.*;
import javax.vecmath.*;

public class TextureModeExample extends BasicSceneWithMouseControl 
{
  public static void main(String args[]){new TextureModeExample();}
  
  public BranchGroup createContentBranch() 
  {
    BranchGroup root = new BranchGroup();
   
    Appearance appearance = new Appearance();
    
    // Create a white material
    Material material = new Material();
    material.setAmbientColor(new Color3f(1.0f, 1.0f, 1.0f));
    material.setDiffuseColor(new Color3f(1.0f, 1.0f, 1.0f));
    appearance.setMaterial(material);
    
    Texture earthTexture = null;
    try
    {
      // Load the earth texture
      TextureLoader loader = new TextureLoader("earth.jpg", this);
      earthTexture = loader.getTexture();
      
    }
    catch(Exception e){System.out.println(e.toString());}
    appearance.setTexture(earthTexture);
    
    // Set the texture mode to modulate
    TextureAttributes textureAttributes = new TextureAttributes();
    textureAttributes.setTextureMode(TextureAttributes.MODULATE);
    appearance.setTextureAttributes(textureAttributes);
    
    // Create a sphere primtive with texture coordinates and normals
    Sphere sphere = new Sphere(0.5f,
        Sphere.GENERATE_TEXTURE_COORDS|Sphere.GENERATE_NORMALS, 
        50, appearance);
    root.addChild(sphere);
    
    // Create a bright white directional light
    DirectionalLight light = new DirectionalLight(new Color3f(1.0f, 1.0f, 1.0f), 
        new Vector3f(-1.0f, -1.0f, -1.0f)); 
    light.setInfluencingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    root.addChild(light);
    
    // Create a dark white ambient light
    AmbientLight ambientLight = new AmbientLight(new Color3f(0.2f, 0.2f, 0.2f)); 
    ambientLight.setInfluencingBounds(new BoundingSphere(new Point3d(), 
        Double.MAX_VALUE));
    root.addChild(ambientLight);
    
    root.compile();

    return root;
  }
}

